# coding: utf-8

"""
    Spacestudio API documentation

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Plot(BaseModel):
    """
    Plot
    """ # noqa: E501
    id: Optional[StrictInt] = None
    axis_param_x: Optional[StrictStr] = Field(default=None, description="Parameter to render x axis", alias="axisParamX")
    axis_param_y: Optional[List[StrictStr]] = Field(default=None, description="Parameters to render y axis", alias="axisParamY")
    axis_param_z: Optional[StrictStr] = Field(default=None, description="Parameter to render z axis", alias="axisParamZ")
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["id", "axisParamX", "axisParamY", "axisParamZ", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['BAR_CHART', 'LINE_CHART', 'HEAT_MAP', 'EPHEMERIS']):
            raise ValueError("must be one of enum values ('BAR_CHART', 'LINE_CHART', 'HEAT_MAP', 'EPHEMERIS')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Plot from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Plot from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "axisParamX": obj.get("axisParamX"),
            "axisParamY": obj.get("axisParamY"),
            "axisParamZ": obj.get("axisParamZ"),
            "type": obj.get("type")
        })
        return _obj


