# coding: utf-8

"""
    Spacestudio API documentation

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field
from typing import Any, ClassVar, Dict, List, Optional, Union
from spacestudio_satellite_client.models.computation_mode import ComputationMode
from spacestudio_satellite_client.models.context_outputs import ContextOutputs
from spacestudio_satellite_client.models.maneuver import Maneuver
from typing import Optional, Set
from typing_extensions import Self

class StudyParameters(BaseModel):
    """
    StudyParameters
    """ # noqa: E501
    computation_mode: Optional[ComputationMode] = Field(default=None, alias="computationMode")
    maneuver: Optional[Maneuver] = None
    context_outputs: Optional[ContextOutputs] = Field(default=None, alias="contextOutputs")
    __properties: ClassVar[List[str]] = ["computationMode", "maneuver", "contextOutputs"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[str] = 'computationMode'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ANALYTICAL': 'AnalyticalStudyParameters','NUMERICAL': 'NumericalStudyParameters'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict[str, Any]) -> Optional[str]:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Union[Self, Self]]:
        """Create an instance of StudyParameters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of maneuver
        if self.maneuver:
            _dict['maneuver'] = self.maneuver.to_dict()
        # override the default output from pydantic by calling `to_dict()` of context_outputs
        if self.context_outputs:
            _dict['contextOutputs'] = self.context_outputs.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Optional[Union[Self, Self]]:
        """Create an instance of StudyParameters from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("StudyParameters failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

# TODO: Rewrite to not use raise_errors
StudyParameters.model_rebuild(raise_errors=False)

